#define INCL_KBD
#include <lucier.h>
#include "HOOKGLBL.H"
 
/***********************************************************************/
/*  O[oϐ                                                     */
/***********************************************************************/
HAB      habDLL;
// HMODULE  hMod;
PFN      pfnInput;
PFN      pfnMsgHook,pfnTaskHook;

/***********************************************************************/
/*  InitDLL: ̊֐ DLL ZbgbvASϐݒ肵܂B       */
/***********************************************************************/

void _export EXPENTRY InitDLL(HAB hab) {
   habDLL = hab;
}
void _export EXPENTRY TermDLL() {
}
 
/***********************************************************************/
/*  StartInputHook: ̊֐̓tbNEtB^[Jn܂B         */
/***********************************************************************/
int  _export EXPENTRY StartInputHook(HWND hwnd)  {
PSHARE   pShare;
HMODULE  hMod=NULLHANDLE;
   DosLoadModule(NULL, 0, HOOK_DLL, &hMod);
   DosQueryProcAddr(hMod, 5, "InputProc", &pfnInput);
   if(!DosGetNamedSharedMem(&pShare,SHAREMEMNAME,PAG_WRITE))  {
      if(pShare->fHookNow) {
         DosFreeModule(hMod);
         return 1L;
      }
   }
   pShare->fHookNow=TRUE;
   pShare->hwndHook=hwnd;
   pShare->hmod=hMod;
   pShare->ptrArrow=WinLoadPointer(HWND_DESKTOP,pShare->hmod,5);
   WinSetHook(habDLL, NULLHANDLE, HK_INPUT, pfnInput, hMod);
   WinSetHook(habDLL, NULLHANDLE, HK_SENDMSG, pfnInput, hMod);
return NO_ERROR; }
  
/***********************************************************************/
/*  StopInputHook: ̊֐̓tbNEtB^[~܂B          */
/***********************************************************************/
int   _export EXPENTRY StopInputHook(HWND hwnd)   {
PSHARE   pShare;
   if(DosGetNamedSharedMem(&pShare,SHAREMEMNAME,PAG_WRITE))    return 1L;
   if(!pShare->fHookNow)   return 2L;
   if(pShare->hwndHook!=hwnd)   return 3L;
   WinDestroyPointer(pShare->ptrArrow);
   WinReleaseHook(habDLL, NULLHANDLE, HK_SENDMSG, pfnInput, pShare->hmod);
   WinReleaseHook(habDLL, NULLHANDLE, HK_INPUT, pfnInput, pShare->hmod);
   pShare->fHookNow=FALSE;
   DosFreeModule(pShare->hmod);
return NO_ERROR;  }
 
/***********************************************************************/
/*  InputProc: ͓̓tB^[E[`łB                    */
/*  tbNANeBułԁAׂẴbZ[W͂oA   */
/*  fBXpb`܂B                                             */
/***********************************************************************/
BOOL _export EXPENTRY InputProc(HAB hab, PQMSG pqMsg, ULONG fs)  {
PSHARE   pShare;
HWND     hwnd;
ULONG    rc;
MPARAM   mp1,mp2;
HPOINTER  ptrArrow;

   switch(pqMsg->msg)   {
   case WM_BUTTON2DOWN:
      if(DosGetNamedSharedMem(&pShare,SHAREMEMNAME,PAG_WRITE))  {
         return FALSE;
      }
      switch(pShare->fMoveOK)   {
      case 0:
         break;
      case 1:
         hwnd=WinQueryWindow(pqMsg->hwnd,QW_PARENT);
         ptrArrow=WinLoadPointer(HWND_DESKTOP,pShare->hmod,5);
         WinSetPointer(HWND_DESKTOP,ptrArrow);
         EscTrackWindowMove(WinQueryWindow(hwnd,QW_PARENT),hwnd);
         WinSetPointer(HWND_DESKTOP,WinQuerySysPointer(HWND_DESKTOP,SPTR_ARROW,FALSE));
         WinDestroyPointer(ptrArrow);
         return TRUE;
      case 2:
         hwnd=pqMsg->hwnd;
         ptrArrow=WinLoadPointer(HWND_DESKTOP,pShare->hmod,6);
         WinSetPointer(HWND_DESKTOP,ptrArrow);
         EscTrackWindowMove(WinQueryWindow(hwnd,QW_PARENT),hwnd);
         WinSetPointer(HWND_DESKTOP,WinQuerySysPointer(HWND_DESKTOP,SPTR_ARROW,FALSE));
         WinDestroyPointer(ptrArrow);
         return TRUE;
      }
      return FALSE;
   case WM_CHAR:
      mp1=pqMsg->mp1;
      mp2=pqMsg->mp2;
      if( (SHORT1FROMMP(mp1)&KC_VIRTUALKEY) && (SHORT1FROMMP(mp1)&KC_LONEKEY))  {
         switch( SHORT2FROMMP(mp2)) {
         case VK_F12:
            if(DosGetNamedSharedMem(&pShare,SHAREMEMNAME,PAG_WRITE))  {
               return FALSE;
            }
            if(!pShare->hwndWindow) return FALSE;
            WinPostMsg(pShare->hwndWindow,WM_USER,0,0);
            return TRUE;
         }
      }
      return FALSE;
   }
return FALSE;  }
  

int __dll_initialize(void) {
PSHARE   pShare;
   if(DosAllocSharedMem(&pShare,SHAREMEMNAME,sizeof(SHARE),PAG_COMMIT|PAG_WRITE))  {
      DosGetNamedSharedMem(&pShare,SHAREMEMNAME,PAG_WRITE);
   }
   if(!pShare)    {
      return 0;
   }
   memset(pShare,0,sizeof(SHARE));
return 1; }

int __dll_terminate(void) {
PSHARE   pShare;
   if(!DosGetNamedSharedMem(&pShare,SHAREMEMNAME,PAG_WRITE))  {
      if(pShare)  {
         DosFreeMem(pShare);
      }
   }
return 1; }

