/* ******************************************************************** */
/* PM MSG HOKK                                                          */
/* ******************************************************************** */
/* Copyrights(c)1996-2000, TM2LABO               , All Rights Reserved. */
/* ******************************************************************** */
#include <LUCIER.H>
#include "HOOKMAIN.H"
#include "HOOKGLBL.H"
#include "DIALOG.H"

CHAR szTITLE[]="\n---\nTITLE: PM WINDOW MAST MOVE";
CHAR szVERSION[]="\nVERSION: 1.0.0";
CHAR szRELEASE[]="\nRELEASE: 2000/11/13";
CHAR szCOPYRIGHT[]="\nCOPYRIGHT: Copyrights(c)1996-2000, TM2LABO, All Rights Reserved.";
CHAR szCODE[]="\nLABOCODE: adskjadfvcewrvwrvcdrwertwwrt7509\n---\n";

PSZ   papszTitle[]={"MAST MOVE","Έړ"};
PSZ   papszMode1[]={"","eΈړ","ʐΈړ"};
PSZ   papszMode2[]={"INVALID","PARENT","PERSONAL"};
ULONG paFreq[]={220,440,880};
PSZ   papszInvalidity[]={"Invalidity",""};
ULONG fHook=0L;

typedef struct {
   HAB   hab;
   HMQ   hmq;
   QMSG  qmsg;
   HPOINTER hPtr;
   BOOL  fSaved;
   BOOL  fJapanese,fBeep;
   HWND  hwndFrame,hwndText;
   HWND  hwndHelpInstance;
}  GLOBAL, *PGLOBAL;
PGLOBAL pGlobal;


MRESULT EXPENTRY TextProc(HWND hwnd, ULONG msg, MPARAM mp1, MPARAM mp2) {
   switch(msg) {
   case WM_INITDLG:
      break;
   case WM_CLOSE:
      break;
   }
return WinDefDlgProc( hwnd, msg, mp1, mp2 );  }

MRESULT EXPENTRY DialogProc(HWND hwnd, ULONG msg, MPARAM mp1, MPARAM mp2) {
PSHARE   pShare;
QMSG  qMsg;
ULONG idx;
PSZ   psz;
ULONG i,k;
USHORT   usValue;

   switch(msg) {
   case WM_INITDLG:
      InitDLL(pGlobal->hab);
      if(StartInputHook(hwnd))   {
         WinMessageBox(HWND_DESKTOP,HWND_DESKTOP,"HOOK DLL ALREADY USED","HOOK ERROR",
            0, MB_ERROR|MB_MOVEABLE);
         WinPostMsg(hwnd,WM_QUIT,0,0);
         return FALSE;
      }
      pGlobal->hPtr=WinLoadPointer(HWND_DESKTOP,0,1);
      WinSendMsg(hwnd,WM_SETICON,(MPARAM)pGlobal->hPtr,NULL);
      EscSetWindowTitleToTasklist(hwnd, papszTitle[pGlobal->fJapanese]);
      WinSetWindowText(hwnd, papszTitle[pGlobal->fJapanese]);
      /* p[̎ */
      if(DosGetNamedSharedMem(&pShare,SHAREMEMNAME,PAG_WRITE))  {
         /* p[gps\ */
         return FALSE;
      }
      pShare->hwndWindow=hwnd;
      pShare->fMoveOK=0;
      if(pGlobal->fJapanese)  {
         WinSetWindowText(WinWindowFromID(hwnd,ID_BTN_CONTROL), papszMode1[pShare->fMoveOK]);
      }  else  {
         WinSetWindowText(WinWindowFromID(hwnd,ID_BTN_CONTROL), papszMode2[pShare->fMoveOK]);
      }
      WinRestoreWindowPos("TM2LABO","MASTMOVE",hwnd);
      break;
   case WM_SAVEAPPLICATION:
      if(!pGlobal->fSaved)  {
         WinStoreWindowPos("TM2LABO","MASTMOVE",hwnd);
         pGlobal->fSaved=TRUE;
      }
      pGlobal->fSaved=TRUE;
      break;
   case WM_CLOSE:
      if(!pGlobal->fSaved)  {
         WinStoreWindowPos("TM2LABO","MASTMOVE",hwnd);
         pGlobal->fSaved=TRUE;
      }
      WinDestroyPointer(pGlobal->hPtr);
      WinPostMsg( hwnd, WM_QUIT, 0L, 0L );
      break;
   case WM_HELP:
      break;
   case WM_COMMAND:
      switch(SHORT1FROMMP(mp1))  {
      case ID_CLOSE:
         WinPostMsg(hwnd,WM_CLOSE,0,0);
         break;
      case ID_BTN_CONTROL:
         WinPostMsg(hwnd,WM_USER,0,0);
         break;
      }
      return 0L;
   case WM_USER:
      if(DosGetNamedSharedMem(&pShare,SHAREMEMNAME,PAG_WRITE))  {
         return FALSE;
      }
      pShare->fMoveOK++;
      if(pShare->fMoveOK>=3)   {
         pShare->fMoveOK=0;
      }
      if(pGlobal->fJapanese)  {
         WinSetWindowText(WinWindowFromID(hwnd,ID_BTN_CONTROL), papszMode1[pShare->fMoveOK]);
      }  else  {
         WinSetWindowText(WinWindowFromID(hwnd,ID_BTN_CONTROL), papszMode2[pShare->fMoveOK]);
      }
      if(pGlobal->fBeep)   {
         DosBeep(paFreq[pShare->fMoveOK],50);
      }
      break;
   case WM_BUTTON2DOWN:
      EscTrackWindowMove(HWND_DESKTOP,hwnd);
      break;
   case WM_LUCIER_FINDARGV:
      if(!mp1 || EscStrEq(mp1,""))   {
         break;
      }
      if(EscStrEq(mp1,"/L")||EscStrEq(mp1,"/LANG"))   {
         if(EscStrEq(mp2,"/JPN")||EscStrEq(mp2,"/JP")||EscStrEq(mp2,"/J"))   {
            pGlobal->fJapanese=TRUE;
         }
         if(EscStrEq(mp2,"/ENG")||EscStrEq(mp2,"/EN")||EscStrEq(mp2,"/E")||EscStrEq(mp2,"/US")||EscStrEq(mp2,"/UK"))   {
            pGlobal->fJapanese=TRUE;
         }
      }
      if(EscStrEq(mp1,"/ENG")||EscStrEq(mp1,"/EN")||EscStrEq(mp1,"/E")||EscStrEq(mp1,"/US")||EscStrEq(mp1,"/UK"))   {
         pGlobal->fJapanese=FALSE;
      }
      if(EscStrEq(mp1,"/B")||EscStrEq(mp1,"/BEEP"))   {
         pGlobal->fBeep=TRUE;
      }
      break;
   }
return WinDefDlgProc( hwnd, msg, mp1, mp2 );  }


void main(int argc,char *argv[])   {

   pGlobal=EscAllocMem(sizeof(GLOBAL)); /* pGlobal is defined in GLOBAL.C */
   if(!pGlobal)   exit(1);
   memset(pGlobal,0,sizeof(GLOBAL));

   pGlobal->hab = WinInitialize(0);
   pGlobal->hmq = WinCreateMsgQueue(pGlobal->hab,0);       

   pGlobal->fJapanese=EscReadyForJapanese();
   EscFindArgv(argc,argv,DialogProc,NULL);

   pGlobal->hwndFrame = WinLoadDlg( HWND_DESKTOP, HWND_DESKTOP, ( PFNWP )DialogProc, NULLHANDLE, ID_DIALOG, NULL);

   /* ***************************************************************** */
   /* bZ[W[v                                                  */
   /* ***************************************************************** */
   while( WinGetMsg( pGlobal->hab, &pGlobal->qmsg, (HWND) NULL, 0, 0 ) )
      WinDispatchMsg( pGlobal->hab, &pGlobal->qmsg );
   WinDismissDlg( pGlobal->hwndFrame, TRUE );

   StopInputHook(pGlobal->hwndFrame);
   TermDLL(pGlobal->hab);
   WinDestroyWindow(pGlobal->hwndFrame);
   WinDestroyMsgQueue( pGlobal->hmq );
   WinTerminate( pGlobal->hab );

exit(0);  } 
